#   PorgamRays Setup aand Control

set frame  PorgamRays
set title "PorgamRays Setup"
set icon   PorgamRays

set started 0
set verbose 0

set inputcolour  green4
set outputcolour red
set insertcolour blue
set bkgcolour    azure

set inputprompt  ""
set outputprompt ""
set insertprompt ">>"


set XPRAYSNUCAMAccessServerHost  "localhost"
variable WebServer

set RegisterBase 0x0
set RegisterBase1 0x10000
set RegisterBase0 0x20000
set RegisterBase2 0x00000

set DetectorList [list 1 2 3 4 5 6 7]
set ASICAddrList [list -1 -1 -1 -1 -1 -1 -1 -1]

set Detector -1
set ASICAddr -1

#    ASIC register values

set PreAmpGain 0
set ShapingTime 2
set PreAmpBias 6

set RiseTime 0
set ADCRange 0
set ChipBiasCurrent 9

for {set i 0} {$i <= 99} {incr i} {set CALRegister($i) 0}
# Calibration bit to select a channel 0 or 1  !
set Cal_bit 0
set savefile ""
set savedirectory ""



proc bgerror err {
    global errorInfo tkerrorInfo tkskiperror
    upvar #0 MIDAS_SOAPFaultCode FaultCode
    upvar #0 MIDAS_SOAPFaultString FaultString
    upvar #0 MIDAS_SOAPErrorCode ErrorCode
    upvar #0 MIDAS_SOAPErrorInfo ErrorInfo

    if {$tkskiperror == 1} then {set tkskiperror 0; return}
    set tkerrorInfo $errorInfo

    if {[grab current .] != ""} then {grab release [grab current .]}

    catch {:modify [self frame-name] :busy T}
    if {![info exists FaultCode] || $FaultCode == "NONE"} {
        set z [catch {midas_dialog [self frame-name].tkerrorDialog "Error Detected in Tcl Script" \
                "Task '[Get_My_Name]' detected error in Tcl script\n\n$err" "error" 0 "continue" "Stack Trace"} button]
    } else {
        set z [catch {midas_dialog [self frame-name].tkerrorDialog "Error Detected in Tcl Script" \
                "Task '[Get_My_Name]' detected error in Tcl script\n\n$FaultCode\n$FaultString\n$ErrorCode\n$ErrorInfo" \
                       "error" 0 "continue"} button]
    }
    catch {:modify [self frame-name] :busy F}

    if {$z != 0} then {
       puts stderr "midas_dialog: [self frame-name].tkerrorDialog: $button"
       destroy [self frame-name].tkerrorDialog
       return
    }

    if {$button != 0} then {tkStackTrace}
}

proc Set_Register {Addr Vl}  {
    global errorCode errorInfo
    global RegisterBase

        set rc [catch {XPRAYSNUCAMAccessClient__Set [expr $RegisterBase + $Addr] $Vl} m]
        if {$rc != 0} {
            InsertLog  "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

proc Get_Register {Addr}  {
    global errorCode errorInfo
    global RegisterBase

        set rc [catch {XPRAYSNUCAMAccessClient__Get [expr $RegisterBase + $Addr]} m]
        if {$rc != 0} {
            InsertLog  "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

proc Set_Register2 {Addr Vl}  {
    global errorCode errorInfo
    global RegisterBase2

        set rc [catch {XPRAYSNUCAMAccessClient__Set [expr $RegisterBase2 + $Addr] $Vl} m]
        if {$rc != 0} {
            InsertLog  "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

proc Get_Register2 {Addr}  {
    global errorCode errorInfo
    global RegisterBase2

        set rc [catch {XPRAYSNUCAMAccessClient__Get [expr $RegisterBase2 + $Addr]} m]
        if {$rc != 0} {
            InsertLog  "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

proc Set_Register1 {Addr Vl}  {
    global errorCode errorInfo
    global RegisterBase1

        set rc [catch {XPRAYSNUCAMAccessClient__Set [expr $RegisterBase1 + $Addr] $Vl} m]
        if {$rc != 0} {
            InsertLog  "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

proc Get_Register1 {Addr}  {
    global errorCode errorInfo
    global RegisterBase1

        set rc [catch {XPRAYSNUCAMAccessClient__Get [expr $RegisterBase1 + $Addr]} m]
        if {$rc != 0} {
            InsertLog  "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

proc Set_Register0 {Addr Vl}  {
    global errorCode errorInfo
    global RegisterBase0

        set rc [catch {XPRAYSNUCAMAccessClient__Set [expr $RegisterBase0 + $Addr] $Vl} m]
        if {$rc != 0} {
            InsertLog  "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}

proc Get_Register0 {Addr}  {
    global errorCode errorInfo
    global RegisterBase0

        set rc [catch {XPRAYSNUCAMAccessClient__Get [expr $RegisterBase0 + $Addr]} m]
        if {$rc != 0} {
            InsertLog  "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
}


proc InsertLog {s} {:modify LOG :usingtag taginsert :strings $s\n}


proc click arg {
    global PreAmpGain  ShapingTime  PreAmpBias  RiseTime  TimeStamp  ChipBiasCurrent ADCRange
 
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]

   if {$c==":quit"} then {click-quit; return}
   switch $w {

      RTT	{Write_DAC A $v; after 200 Redisplay_DACSettings}
      ET 	{Write_DAC B $v; after 200 Redisplay_DACSettings}
      CPL	{Write_DAC C $v; after 200 Redisplay_DACSettings}

      PAG       {set PreAmpGain $v; Write_ASICSettings; Redisplay_ASICSettings}
      ST        {set ShapingTime $v; Write_ASICSettings; Redisplay_ASICSettings}
      PAB       {set PreAmpBias $v; Write_ASICSettings; Redisplay_ASICSettings}
      RT        {set RiseTime $v; Write_ASICSettings; Redisplay_ASICSettings}
      ADR        {set ADCRange $v; Write_ASICSettings; Redisplay_ASICSettings}
      CBC       {set ChipBiasCurrent $v; Write_ASICSettings; Redisplay_ASICSettings}

      DETECTOR  {select_Detector $v; do_redisplay}
   
      default {
         set p "click-[lowercase $w]"
         if {[info procs $p] == "$p"} then {$p $v} else {set-footer "no handler for widget $w"}
      }
   }
}

proc select_Detector {v} {
    global Detector DetectorList ASICAddr ASICAddrList

    set detector [lindex $DetectorList $v]
    set asic [lindex $ASICAddrList $detector]

    if {$asic == -1} {midas-warning "This detector does not have a valid ASIC address"; return}

    set Detector $detector
    set ASICAddr $asic

     set rc [Set_Register0 11 $Detector]
     set rc [Set_Register0 12 $ASICAddr]

     set rc [Set_Register0 27 $Detector]

}

proc make_register {widget} {

     :layout H; :row-gap 0; :next-row T

     for {set j 0} {$j < 10} {incr j} {

        :canvas [set widget]DECADE$j  :w 320 :h 35

        for {set i 0} {$i < 10} {incr i} {
           set y 20
           set x [expr $i * 30  + 20]
           if {$i > 4} then {incr x 10}
           entry [:path [set widget]DECADE$j].bit$i -relief flat -width 2 -justify right
           set Ch [expr ($j*10)+$i]
           [:path [set widget]DECADE$j].bit$i insert 0 "$Ch"
           :draw window :tag [set widget]bit$i :value $x $y -window [:path [set widget]DECADE$j].bit$i 

           bind [:path [set widget]DECADE$j].bit$i <ButtonPress-1>  "set_register_bit $widget $j $i"
        }

        :next-row T
     }
     :row-gap 10
     :vskip 10
}

proc show_register {widget} {
    global env
    global [set widget]Register

     for {set j 0} {$j < 10} {incr j} {
        for {set i 0} {$i < 10} {incr i} {
           set bit [expr ($j*10)+$i]
#           [:path [set widget]DECADE$j].bit$i delete 0 end
#           [:path [set widget]DECADE$j].bit$i insert 0 [set [set widget]Register($bit)]
           if {[set [set widget]Register($bit)] == 0} {[:path [set widget]DECADE$j].bit$i configure -bg  $env(tkcheckbuttonbackground)} \
               else {[:path [set widget]DECADE$j].bit$i configure -bg  $env(tkcheckbuttonselectcolor)}
        }
     }
}

proc set_register_bit {widget j i} {
    global env
    global [set widget]Register

    set bit [expr ($j*10)+$i]
    set vl  [set [set widget]Register($bit)]
    set [set widget]Register($bit) [expr ($vl + 1) & 1]

#    [:path [set widget]DECADE$j].bit$i delete 0 end
#    [:path [set widget]DECADE$j].bit$i insert 0 [set [set widget]Register($bit)]
    if {[set [set widget]Register($bit)] == 0} {[:path [set widget]DECADE$j].bit$i configure -bg  $env(tkcheckbuttonbackground)} \
        else {[:path [set widget]DECADE$j].bit$i configure -bg  $env(tkcheckbuttonselectcolor)}

}

proc click-setcal  {args} {
    global errorCode errorInfo
    global CALRegister Cal_bit

    set Vl ""
    for {set bit 0}   {$bit <= 13}  {incr bit} {append Vl " 0"}
    for {set bit 14}  {$bit <= 113} {incr bit} {append Vl " [set CALRegister([expr $bit-14])]"}
    for {set bit 114} {$bit <= 127} {incr bit} {append Vl " 0"}

    set reg 0
    for {set bit 31} {$bit >= 0}  {incr bit -1} {
       if {[lindex $Vl [expr 0 + $bit]] == 1} {set reg [expr ($reg << 1) + 1]} else {set reg [expr $reg << 1]}
    }
    # test to see if this ASIC uses inverse select 
    if { $Cal_bit == 0 } {
	set nreg [ expr ~$reg ]
	set msbit [ expr ( $reg >> 31 ) & 1 ]
	if { $msbit == 0 } {
		set nreg [ expr $nreg | 0x80000000 ]
	}
	set reg $nreg 
    }
    set preg [format 0x%x $reg]

    insert-debug "Setting calibration register 16 to $preg "
    Set_Register0 16 [format 0x%x $reg]
#   Set_Register0 16 $reg

    set reg 0
    for {set bit 31} {$bit >= 0}  {incr bit -1} {
       if {[lindex $Vl [expr 32 + $bit]] == 1} {set reg [expr ($reg << 1) + 1]} else {set reg [expr $reg << 1]}
    }
        # test to see if this ASIC uses inverse select 
    if { $Cal_bit == 0 } {
	set nreg [ expr ~$reg ]
	set msbit [ expr ( $reg >> 31 ) & 1 ]
	if { $msbit == 0 } {
		set nreg [ expr $nreg | 0x80000000 ]
	}
	set reg $nreg 
    }
    set preg [format 0x%x $reg]

    insert-debug "Setting calibration register 17 to $preg"
    Set_Register0 17 [format 0x%x $reg]

    set reg 0
    for {set bit 31} {$bit >= 0}  {incr bit -1} {
       if {[lindex $Vl [expr 64 + $bit]] == 1} {set reg [expr ($reg << 1) + 1]} else {set reg [expr $reg << 1]}
    }
    # test to see if this ASIC uses inverse select 
    if { $Cal_bit == 0 } {
	set nreg [ expr ~$reg ]
	set msbit [ expr ( $reg >> 31 ) & 1 ]
	if { $msbit == 0 } {
		set nreg [ expr $nreg | 0x80000000 ]
	}
	set reg $nreg 
    }
    set preg [format 0x%x $reg]

    insert-debug "Setting calibration register 18 to $preg"
    Set_Register0 18 [format 0x%x $reg]

    set reg 0
    for {set bit 31} {$bit >= 0}  {incr bit -1} {
       if {[lindex $Vl [expr 96 + $bit]] == 1} {set reg [expr ($reg << 1) + 1]} else {set reg [expr $reg << 1]}
    }
        # test to see if this ASIC uses inverse select 
    if { $Cal_bit == 0 } {
	set nreg [ expr ~$reg ]
	set msbit [ expr ( $reg >> 31 ) & 1 ]
	if { $msbit == 0 } {
		set nreg [ expr $nreg | 0x80000000 ]
	}
	set reg $nreg 
    }
    set preg [format 0x%x $reg]

    insert-debug "Setting calibration register 19 to $preg"
    Set_Register0 19 [format 0x%x $reg]

    set vl [Get_Register0 24]
    Set_Register0 24 [expr ($vl & 0xfe) + 1]   ;# load the ASIC
    Set_Register0 24 $vl

}

proc do_ClearAll {} {
    global CALRegister

    for {set i 0} {$i <= 99} {incr i} {set CALRegister($i) 0}

   show_register CAL
}

proc do_IF_Reset {} {
     set r [Get_Register0 24]
     Set_Register0 24 [expr ($r & 0x77) + 0x88]     ;# toggle bit 7
     Set_Register0 24 [expr ($r & 0x77) + 0x08]     ;#  set bit 3

    update_control
}

proc do_ASIC_Reset {} {
     set r [Get_Register0 24]
     Set_Register0 24 [expr ($r & 0xfb) + 0x04]     ;# toggle bit 2
     after 100
     Set_Register1 0x0400 [expr ($r & 0xfb)]

     do_redisplay
}

proc click-control {vl} {

    Set_Register0 24 [expr $vl & 0x8e] ; update_control
}

proc update_control {} {:modify CONTROL :value [Get_Register0 24]}

proc click-calselect {vl} {

    Set_Register0 28 [expr $vl & 0xfe] ; update_calselect
}

proc update_calselect {} {:modify CALSELECT :value [Get_Register0 28]}

proc click-calrate {vl} {

    Set_Register0 26 $vl; update_calrate
}

proc update_calrate {} {:modify CALRATE :value [Get_Register0 26]}

proc Restore {} {                         ;# used by SETUP
#    upvar #0 savefile filename
# problems with the ASIC registers make this too difficult in the short term
#    if {$filename == "undefined"} {do_Restore} else {do_restore}
}

proc Reset {} {                        ;# used by SYS
    global Detector DetectorList ASICAddr ASICAddrList
    
    Set_Register1 0 0x7804     ;#   control register, reset the spartan and all the asics
    Set_Register1 0 0x7800     ;#   control register

    Set_Register2 0 0xe000     ;#   set control register, reset the ML403 peripheral
    Set_Register2 0 0          ;#   clear control register

#    reset the timestamp to zero

    Set_Register0 64 0   ;# clear enable
    Set_Register0 68 0   ;# clear LSBs
    Set_Register0 69 0   ;# clear MSBs
    Set_Register0 64 1   ;# set enable

#    stop calibration pulser and remove CACT

    Set_Register0 24 8
# deselect all CSIG routing 
    Set_Register0 28 0
    
#    reset all detectors 

      foreach detector $DetectorList {
          set ASICAddr [lindex $ASICAddrList $detector]
         if {$ASICAddr == -1} {continue}

          Set_Register0 [expr $detector << 8] 0xc000   ;# reset
          Set_Register0 [expr $detector << 8] 0
      }

}

proc Stop {} {                        ;# used by SYS
    global Detector DetectorList ASICAddr ASICAddrList
# stop the readout in the ML403
	Set_Register2 0 0
# stop readout in the Spartan
	Set_Register0 48 0
#    reset readout in the Spartan 

#     Set_Register0 48 1

 #    Set_Register2 0 0xe000 
}

proc Go {} {                        ;# used by SYS
    global Detector DetectorList ASICAddr ASICAddrList

#    reset readout in the Spartan 

     Set_Register0 48 1
     Set_Register0 48 0
# reset readout state machines in the ML403

     Set_Register2 0 0xe000 
     Set_Register2 0 0

     Set_Register2 0 1        ;# enable readout in the ML403

# enable readout in the detectors that are present

      foreach detector $DetectorList {
           set ASICAddr [lindex $ASICAddrList $detector]
           if {$ASICAddr == -1} {continue}

          Set_Register0 [expr $detector << 8]  3
      }

}

proc do_Save {} {
    global env
    upvar #0 savedirectory  directory
    upvar #0 savefile filename
    global Detector DetectorList ASICAddr ASICAddrList


    	option add *Canvas.background  #c0c020
	set types {
	{ {Data Files} {*.dat} }
	{ {All Files } {*} }
	}

	set f [tk_getSaveFile -parent [self frame-name] \
		  -title "Save File Selection"  \
		  -initialdir $directory -filetypes $types]
	option add *Canvas.background  $env(tkcanvasbackground)
	if {$f == ""} then {return}

      if {[file extension $f] == ""} then {append f .dat}

      set filename $f   ;#  remember current choice
      set directory [file dirname $f]
      Save_Options

      set z [catch {open $filename w} f]
      if {$z != 0} then {
          midas-warning "Cannot create/open file $filename\n$f"
          return
      }

      set DetectorSAVE $Detector

      foreach Detector $DetectorList {
           set ASICAddr [lindex $ASICAddrList $Detector]
           if {$ASICAddr == -1} {continue}

           select_Detector [lsearch $DetectorList $Detector]
         
           foreach item [list 0 1] {         ;# ASIC Registers
               set vl [Read_ASICregister $item]
               puts $f "$Detector ASICregister $item $vl"
           }

           foreach item [list A B C] {       ;#  DAC Registers
               set vl [Read_DAC $item]
               puts $f "$Detector DAC $item $vl"
           }
      }

      select_Detector [lsearch $DetectorList $DetectorSAVE]

      close $f

     set-footer "Settings saved to $filename"

}

proc do_Restore {} {
    global env
    upvar #0 savedirectory  directory
    upvar #0 savefile filename
    global Detector DetectorList ASICAddr ASICAddrList

    	option add *Canvas.background  #c0c020
	set types {
	{ {Data Files} {*.dat} }
	{ {All Files } {*} }
	}

	set f [tk_getOpenFile -parent [self frame-name] \
		  -title "Save File Selection"  \
		  -initialdir $directory -filetypes $types]
	option add *Canvas.background  $env(tkcanvasbackground)
	if {$f == ""} then {return}

      set filename $f   ;#  remember current choice
      set directory [file dirname $f]
      Save_Options

      do_restore
}

proc do_restore {} {
    global env
    upvar #0 savedirectory  directory
    upvar #0 savefile filename
    global Detector DetectorList ASICAddr ASICAddrList

      set z [catch {open $filename r} f]
      if {$z != 0} then {
          midas-warning "Cannot create/open file $filename\n$f"
          return
      }

      set settings [split [read $f] \n]

      close $f

      set DetectorSAVE $Detector

      foreach setting $settings {
          if {$setting == ""} {continue}

          set detector [first $setting]
          set registertype [second $setting]
          set registerinstance [third $setting]
          set registervalue [fourth $setting]

          if {$detector != $Detector} {
             set ASICAddr [lindex $ASICAddrList $detector]
             if {$ASICAddr == -1} {continue}

             select_Detector [lsearch $DetectorList $detector]
          }

          switch $registertype {
             ASICregister  {Write_ASICregister $registerinstance $registervalue}
             DAC           {Write_DAC $registerinstance $registervalue}
             Register0     {Set_Register0 $registerinstance $registervalue}
          }
       }

      foreach Detector $DetectorList {
           set ASICAddr [lindex $ASICAddrList $Detector]
           if {$ASICAddr == -1} {continue}

           select_Detector [lsearch $DetectorList $Detector]

           set vl [Get_Register0 24]
           Set_Register0 24 [expr ($vl & 0xfe) + 1]   ;# load the ASIC
           Set_Register0 24 $vl
      }

       select_Detector [lsearch $DetectorList $DetectorSAVE]

     set-footer "Settings restored from $filename"
      after 2500 clear-footer
}

proc make-frame {} {
   global env
   global inputcolour outputcolour insertcolour bkgcolour
   global DetectorList

set rows 16
set cols 80

  :frame [self frame-name] :label "[self frame-title]" :icon-name "[self icon-title]"

   :panel P0 :layout T :padx 5 :pady 5
    :layout H; :col-gap 10

     :slider RTT  :label "Rise Time Threshold:" :min 0 :max 255 :value 0
     :slider ET   :label "Energy Threshold:" :min 0 :max 255 :value 0
     :slider CPL  :label "Calibration Pulse Level:" :min 0 :max 255 :value 0

     :next-row T

     :message M1 :label "ASIC Settings" :bold T
     :next-row T
     :choice PAG :label "Derivative Threshold (mV)" :strings [list 80 160]
     :choice-stack ST :label "Shaping Time (us)" :strings [list - 0.5 1.0 1.5 2.0 2.5 3.0 2.5 4.0 4.5 5..0 5.5 6.0 6.5 7.0 7.5]
     :choice-stack PAB :label "PreAmp Bias (nA)" :strings [list 0.25 0.5 0.75 1 1 2 3 4]
     :choice RT :label "Collection Time (MHz)" :strings [list 8 4]
     :choice ADR :label "ADC Range" :strings [list low  high ]
     :choice-stack CBC :label "Chip Bias Current (uA)" :strings [list 450 433 417 400 383 367 350 333 317 300 283 \
                       267 250 233 217 200 250 233 217 200 183 167 150 133 117 100 83 67 50 33 17]

   :panel P1A :layout L :padx 100 :pady 5
    :layout V; :col-gap 10

     :message M3 :label "Calibration Register" :bold T
      make_register CAL
     :button CALCLR :label "Clear All" :command do_ClearAll

   :panel P1B :layout R :padx 50 :pady 50
    :layout H; :col-gap 20; :row-gap 20

     :choice DETECTOR  :label "Detector No"  :strings $DetectorList :exclusive T 
     :text   ASICADDR  :label "ASIC Address" :deaf T :w 4

     :next-row T
     :layout V

     :button SETCAL     :label "Set Calibration Register"
 #    :button RESET      :label "Calibration Reset" :command do_IF_Reset
     :choice CONTROL    :label "Calibration Control" :strings [list 0 "CACT" "CSIG" "Disable Pulser" 4 5 6 "CRRES"] :exclusive F
     :choice CALSELECT  :label "Calibration Select" :strings [list 0 1 2 3 4 5 6 7] :exclusive F
     :slider CALRATE    :label "Pulse Rate" :min 0 :max 65536
#     :button ASIC       :label "ASIC Reset" :command do_ASIC_Reset

     :next-row T
     :layout H
     :vskip 50

 #    :button SAVE    :label "Save Settings"       :command do_Save
  #   :button RESTORE :label "Restore Settings"    :command do_Restore

   :panel P2 :layout B :padx 5 :pady 5  :after FOOTER
    :galley LOG :rows $rows :cols $cols :font fixed

   :panel LAST :layout B :padx 5 :pady 5 :after FOOTER
    :layout H; :col-gap 20

     :button REDISPLAY :command do_redisplay
     :hskip 100
     :button CLEAR   :label "Empty Log Window" :command ":modify LOG :empty T"

   open-frame

  :galley_size LOG $rows $cols

    :modify LOG :createtag "taginput  -foreground $inputcolour  -background $bkgcolour"
    :modify LOG :createtag "tagoutput -foreground $outputcolour -background $bkgcolour"
    :modify LOG :createtag "taginsert -foreground $insertcolour -background $bkgcolour"

    :show T

}

proc Save_Options {} {
   global Options


   update_Options
}


proc start args {
   global started env Options ASICAddrList

   if {$started == 0} then {make-frame} else {open-frame}
   set started 1

#    load application options and establish default values for any not defined

   load_Options

   if {![info exists Options(WebServer)]}     {set Options(WebServer) "localhost"}
   if {![info exists Options(savedirectory)]} {set Options(savedirectory) $env(HOME)}
   if {![info exists Options(savefile)]}      {set Options(savefile) "undefined"}

   if {[info exists Options(ASICAddr)]} {
        set ASICAddrList {-1}
        foreach item $Options(ASICAddr) {lappend ASICAddrList $item}
   } else {
        set Options(ASICAddr) "-1 -1 -1 -1 -1 -1 -1"
   }

   update_Options

   foreach option [list WebServer savedirectory savefile] {
       global $option
       set $option $Options($option)
   }

   click-server $Options(WebServer)

}

proc click-server {v} {
    global XPRAYSNUCAMAccessServerHost
    global started

    Save_Options

    set XPRAYSNUCAMAccessServerHost $v

    package require XPRAYSNUCAMAccessClient
    loadsource XPRAYSNUCAMAccessClient     ;# better solution needed

    InsertLog "Initialised XPRAYSNUCAM Web Service at $XPRAYSNUCAMAccessServerHost"

    set started 2

    select_Detector 0

   do_redisplay
}

proc I2C_busy {} {

#    check that the I2C bus is not busy and ready to accept an operation
     
    set vl [Get_Register0 9]     ;# read Status register
    if {$vl == -1} {midas-warning "Error reading I2C Status register"; return -1}
    if {[expr $vl & 1] != 0} {midas-warning "I2C busy"; return -1}
    if {[expr $vl & 8] == 8} {    ;# last operation failed
        Set_Register0 8 1
        set vl [Get_Register0 9]
        if {$vl == -1 || [expr $vl & 9] != 0} {midas-warning "I2C problems event after reset"; return -1}
    }
    
    return 0
}

proc I2C_check {} {

#    check result of last operation on the I2C bus

    set vl [Get_Register0 9]     ;# read Status register
    if {$vl == -1} {midas-warning "Error reading I2C Status register"; return -1}
    if {[expr $vl & 1] != 0} {
        after 2       ;# busy - allow a short delay
        set vl [Get_Register0 9]     ;# read Status register
        if {$vl == -1} {midas-warning "Error reading I2C Status register"; return -1}
        if {[expr $vl & 1] != 0} {midas-warning "I2C bus busy even after delay"; return -1}
    }
    if {[expr $vl & 8] == 8} {midas-warning "I2C bus operation failed"; return -1}

    return 0
}

proc Write_DAC {w vl} {

#    write DAC $w

     switch $w {
         A   {set r 4}
         B   {set r 5}
         C   {set r 6}
         D   {set r 7}
     }

     if {[I2C_busy] != 0} {return -1}

     set rc [Set_Register0 $r [expr 0x2000 + ($vl << 4)]]
     if {$rc == -1} {midas-warning "Error writing DAC $w"; return -1}

     if {[I2C_check] != 0} {return -1}

     return 0
}

proc Read_DAC {w} {

#    read DAC $w

     switch $w {
         A   {set r 4}
         B   {set r 5}
         C   {set r 6}
         D   {set r 7}
     }

     if {[I2C_busy] != 0} {return -1}

     set vl [Get_Register0 $r]
     if {$vl == -1} {midas-warning "Error reading DAC $w"; return -1}

     if {[I2C_check] != 0} {return -1}

     set vl [Get_Register0 10]    ;# get the actual data
     if {$vl == -1} {midas-warning "Error reading DAC $w"; return -1}
 
     set vl [expr ($vl >> 4 ) & 255 ]    ;# extract the byte from the word

     return $vl
}

proc Redisplay_DACSettings {} {

    :modify RTT :value [Read_DAC A]
    :modify ET  :value [Read_DAC B]
    :modify CPL :value [Read_DAC C]

}

proc Read_ASICregister {w} {

#    read ASIC $w   (w = 0 or 1)

     if {[I2C_busy] != 0} {return -1}

     set vl [Get_Register0 $w]
     if {$vl == -1} {midas-warning "Error reading ASIC register $w"; return -1}

     if {[I2C_check] != 0} {return -1}

     set vl [Get_Register0 10]    ;# get the actual data
     if {$vl == -1} {midas-warning "Error reading ASIC register $w"; return -1}

     return $vl
}

proc Write_ASICregister {w vl} {

#    write ASIC $w   (w = 0 or 1)

     if {[I2C_busy] != 0} {return -1}
     set my_vl [ format 0x%x $vl]
     insert-debug "Write ASIC register $w : $my_vl  "

     set vl [Set_Register0 $w $vl]
     if {$vl == -1} {midas-warning "Error writing ASIC register $w"; return -1}

     if {[I2C_check] != 0} {return -1}

     return 0
}

proc Read_ASICSettings {} {
    global PreAmpGain  ShapingTime  PreAmpBias  RiseTime  TimeStamp  ChipBiasCurrent ADCRange

    set vl [Read_ASICregister 0]
    if {$vl == -1} {return}
#    insert-debug "Read ASIC register 1 : $vl  "

    set PreAmpBias [expr $vl & 7]
    set ShapingTime [expr ($vl >> 3) & 15]
    set PreAmpGain [expr ($vl >> 7) & 1]

    set vl [Read_ASICregister 1]
    if {$vl == -1} {return}
#    insert-debug "Read ASIC register 2 : $vl  "

    set ChipBiasCurrent [expr $vl & 0x1f]
    set ADCRange [expr ($vl >> 5) & 1]
    set RiseTime [expr ($vl >> 6) & 1]

}

proc Write_ASICSettings {} {
    global PreAmpGain  ShapingTime  PreAmpBias  RiseTime  TimeStamp  ChipBiasCurrent ADCRange

    set Pre2 [expr $PreAmpBias & 4]
    set Pre10 [expr (~($PreAmpBias & 3)) & 3]
    set vl [expr ($PreAmpGain << 7) + ($ShapingTime << 3) + $Pre2 + $Pre10]
#    insert-debug "Write ASIC register 1 : $vl  "

    Write_ASICregister 0 $vl
     set vl [expr ($RiseTime << 6) + ($ADCRange << 5) + ((~$ChipBiasCurrent) & 0x1f)]
#    insert-debug "Write ASIC register 2 : $vl  "
    Write_ASICregister 1 $vl
}

proc Redisplay_ASICSettings {} {
    global PreAmpGain  ShapingTime  PreAmpBias  RiseTime  TimeStamp  ChipBiasCurrent ADCRange

     Read_ASICSettings

     :modify PAG :value $PreAmpGain
     :modify ST  :value $ShapingTime
     :modify PAB :value $PreAmpBias
     :modify RT  :value $RiseTime
     :modify ADR  :value $ADCRange
     :modify CBC :value $ChipBiasCurrent 

}

proc do_redisplay {} {
    global Detector DetectorList ASICAddr

    set-busy

    :modify DETECTOR :value [lsearch $DetectorList $Detector]
    :modify ASICADDR :value $ASICAddr

    Redisplay_ASICSettings
    Redisplay_DACSettings
    show_register CAL
    update_control
    update_calselect
    update_calrate

    clear-busy
}



#    The Options are experiment specific and normally used by SYS
#    However the same code as for the session preferences is used which allows for wider use in the future.

proc get_Option_file {} {
    global env

#    look for the Option file
    set pd $env(EXPERIMENTBASE)
    if {![file exists $pd]} then {
         insert-log "$pd does not exist - Join an experiment!"
         return {}
    }
    if {![file isdirectory $pd]} then {
         insert-log "$pwd is not useable - it is not a directory"
         return {}
    }
    set pf [file join $pd MidasOptions]
    set z [catch {set f [open $pf r]} m]
    if {$z != 0} then {
        set z [catch {set f [open $pf w]} m]
        if {$z != 0} then {
            insert-log "Unable to access $pf - $m"
            return 1
        }
        close $f
        return {}
    }

#    and read it
    set lines [split [read $f] "\n"]
    close $f

    return $lines
}

proc put_Option_file {lines} {
   global env

#    look for the Option file
    set pd $env(EXPERIMENTBASE)
    if {![file exists $pd]} then {
         insert-log "$pd does not exist - Join an experiment!"
         return {}
    }
    if {![file isdirectory $pd]} then {
         insert-log "$pwd is not useable - it is not a directory"
         return {}
    }
    set pf [file join $pd MidasOptions]
    set z [catch {set f [open $pf w]} m]
    if {$z != 0} then {
        insert-log "Unable to access $pf - $m"
        return 1
    }

    foreach item $lines {
      if {$item != ""} {puts $f $item}
    }

    close $f
    return 0
}

#    save all Options for the current task
proc update_Options {} {
   global env Options

   set lines [get_Option_file]
   set key [Get_My_Name]
   set range [find-keyword $lines $key]
   if {[llength $range] > 0} then {
       set lines [lreplace $lines [first $range] [expr [second $range] + 1]]
   }

   lappend lines "## $key"
   foreach item [array names Options] {
       lappend lines "$item $Options($item)"
   }
   lappend lines "##"

   set z [put_Option_file $lines]
   return $z
}

#    load all Options for the current task
proc load_Options {} {
   global env Options

   set lines [get_Option_file]
   set key [Get_My_Name]
   set range [find-keyword $lines $key]

   if {[llength $range] > 1} then {
       set stuff [lrange $lines [expr [first $range]+1] [second $range]]
       foreach item $stuff {
           set Options([head $item]) [lreplace $item 0 0]
       }
   }
}

#    return task Options
proc get_Options {task} {
   global env

   set lines [get_Option_file]
   set key $task
   set range [find-keyword $lines $key]

   set Options {}

   if {[llength $range] > 1} then {
       set stuff [lrange $lines [expr [first $range]+1] [second $range]]
       foreach item $stuff {
           lappend Options [list [first $item] [second $item]]
       }
   } else {
       lappend Options [list Options.filename  "[file join $env(HOME) MidasOptions Options]"]
   }
   return $Options
}

